<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Instructions</TITLE>
<link href="suif1_23.html" rel=Next>
<link href="suif1_21.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_21.html">previous</A>, <A HREF="suif1_23.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC22" HREF="suif1_toc.html#TOC22">Instructions and Expression Trees</A></H1>
<P>
<A NAME="IDX131"></A>

</P>
<P>
At the leaves of the abstract syntax trees, the <CODE>tree_instr</CODE> nodes
(see section <A HREF="suif1_14.html#SEC14">Instruction Nodes</A>) hold SUIF instructions.  Each instruction
performs a single operation, specified by its opcode.  With just a few
exceptions, the opcodes are simple and straightforward, similar to the
instruction set of a typical RISC processor.  The instructions include
arithmetic, data transfer, and control flow operations.

</P>
<P>
SUIF instructions may be used in two ways.  Most high-level passes use
expression trees, where the instructions are grouped together in trees
that correspond to the expressions in the source programs.  Back-end
optimization passes have traditionally worked with flat lists of
instructions, and SUIF supports that representation as well.

</P>
<P>
The files <TT>`instruction.h'</TT> and <TT>`instruction.cc'</TT> contain the
code for the SUIF instruction classes.

</P>

<UL>
<LI><A HREF="suif1_23.html#SEC23">Basic Features</A>: Features shared by all kinds of instructions.
<LI><A HREF="suif1_30.html#SEC30">Operands</A>: Instruction operands.
<LI><A HREF="suif1_31.html#SEC31">Expression Trees</A>: How to use expression trees.
<LI><A HREF="suif1_32.html#SEC32">Three Operand Instructions</A>: The <CODE>in_rrr</CODE> class (most instructions).
<LI><A HREF="suif1_33.html#SEC33">Branch and Jump Instructions</A>: The <CODE>in_bj</CODE> class.
<LI><A HREF="suif1_34.html#SEC34">Load Constant Instructions</A>: The <CODE>in_ldc</CODE> class.
<LI><A HREF="suif1_35.html#SEC35">Call Instructions</A>: The <CODE>in_cal</CODE> class.
<LI><A HREF="suif1_36.html#SEC36">Array Instructions</A>: The <CODE>in_array</CODE> class.
<LI><A HREF="suif1_37.html#SEC37">Multi-way Branch Instructions</A>: The <CODE>in_mbr</CODE> class.
<LI><A HREF="suif1_38.html#SEC38">Label Instructions</A>: The <CODE>in_lab</CODE> class.
<LI><A HREF="suif1_39.html#SEC39">Generic Instructions</A>: The <CODE>in_gen</CODE> class (non-standard).
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_21.html">previous</A>, <A HREF="suif1_23.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
